Rem

	Dump Box
	(main file)
	
	(c) Copyright 2011 Christian Fiedler
	
	This file is part of Dump Box.
	
	Dump Box is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	
	Mentioning of the authors of BNetEx, which is used in Dump Box:
		Oliver Skawronek and Inkubus
		
	
EndRem

SuperStrict
Framework brl.blitz
Import brl.max2d
?Win32
Import brl.d3d9max2d
?Linux
Import brl.glmax2d
?
Import brl.Graphics
Import brl.timer
Import brl.filesystem
Import brl.retro
Import brl.pngloader
Import vertex.bnetex

Include "lang-de.bmx"
Include "hash.bmx"

Const GW:Int			= 640
Const GH:Int			= 480
Const FELD_BREITE_STD:Int	= GH / 20
Const INITLEV:String		= "init.bin"
Const HIGHSCOREF:String	= "highscore.bin"
Const ROOTSERVF:String		= "server.txt"
Const GFXF:String			= "gfx.png"
Const MENULEVHG:String		= "menu.png"
Const GFXHG:String		= "hg.png"
Const FBLACKLIST:String	= "blacklist.txt"
Const LEVDIREXT:String		= ".lev"
Const INITBAKF:String		= "init_backup.bak"

Global console:String[]
Global tcp:TTCPStream=New TTCPStream, connection:Int=0
Global gfx:TImage,hg:TImage
Global dir:String
Global FELD_BREITE:Int=FELD_BREITE_STD
Global timer:TTimer=CreateTimer(40)
Global currentlevel:String,nextlevel:String
Global player_dir:Int

If Not tcp.init() Then End
tcp.setlocalport
tcp.settimeouts 100,100,100


AppTitle="Dump Box"
Graphics GW, GH
SetBlend ALPHABLEND

'If FileType(ROOTSERVF)=1 Then loadrootservers

Menu
TLevelGroup.SaveChanges
End


Function CloseConnection()
	tcp.close
	If Not tcp.init() Then End
EndFunction

Type TServer
	Global list:TList=New TList
	Global onlineservers:Int
	Field name:String, path:String, ip:Int
	Field cmdlist:String[],online:Int
	Function Create(name:String, path:String, ip:Int)
		Local s:TServer=New TServer
		s.name=name
		s.path=path
		s.ip=ip
		list.addlast s
	EndFunction
	Function UpdateAll()
		Local x:Int Ptr=Int Ptr MemAlloc(4)
		Local t:Int
		x[0]=$02468ACE
		onlineservers=0
		For Local s:TServer=EachIn list
			t=TNetwork.ping(s.ip,Byte Ptr x, 8)
			If t>=0 Then
				tcp.setremoteport 80
				tcp.setremoteip s.ip
				If tcp.connect() Then
					s.online=1
					onlineservers:+1
					CloseConnection
				Else
					s.online=0
				EndIf
			ElseIf t=-1 Then 
				s.online=0
			EndIf
		Next
		MemFree x
	EndFunction
	Function CheckFunctionsAll()
		For Local s:TServer=EachIn list
			If s.online Then s.CheckFunctions
		Next
	EndFunction
	Method CheckFunctions()
		Local s:String
		tcp.setremoteport 80
		tcp.setremoteip ip
		If Not tcp.connect() Then list.remove Self;Return
		tcp.WriteLine "GET "+path+"?f=getcmds HTTP/1.0"
		tcp.WriteLine "Connection: close"
		tcp.WriteLine ""
		tcp.sendmsg
		While Not tcp.recvavail();Wend
		While tcp.recvmsg();Wend
		While tcp.ReadLine();Wend
		While tcp.size()
			s=tcp.ReadLine().Trim()
			If s Then cmdlist:+[s]
		Wend
		CloseConnection
	EndMethod
EndType

Type TTeleport
	Global list:TList=New TList
	Field src_x:Int, src_y:Int
	Field dst_x:Int, dst_y:Int
	Function Create:TTeleport(src_x:Int,src_y:Int,dst_x:Int,dst_y:Int)
		Local t:TTeleport=New TTeleport
		t.src_x=src_x; t.src_y=src_y; t.dst_x=dst_x; t.dst_y=dst_y
		list.addlast t
	EndFunction
	Function drawall(zentral_x:Int,zentral_y:Int)
		For Local t:TTeleport=EachIn list
			t.draw zentral_x,zentral_y
		Next
	EndFunction
	Function deleteteleport(x:Int,y:Int)
		For Local t:TTeleport=EachIn list
			If (t.src_x=x And t.src_y=y) Or (t.dst_x=x And t.dst_y=y) Then list.remove t
		Next
	EndFunction
	Function isteleport:Int(x:Int,y:Int)
		For Local t:TTeleport=EachIn list
			If (t.src_x=x And t.src_y=y) Or (t.dst_x=x And t.dst_y=y) Then Return 1
		Next
		Return 0
	EndFunction
	Function boxteleport(feld:Byte[,] Var, pos_x:Int, pos_y:Int)
		For Local t:TTeleport=EachIn list
			If t.src_x=pos_x And t.src_y=pos_y And feld[t.dst_x,t.dst_y]&$4=0 Then
				feld[pos_x,pos_y]:&(~$4)
				feld[t.dst_x,t.dst_y]:|$4
				Return
			ElseIf t.dst_x=pos_x And t.dst_y=pos_y And feld[t.src_x,t.src_y]&$4=0 Then
				feld[pos_x,pos_y]:&(~$4)
				feld[t.src_x,t.src_y]:|$4
				Return
			EndIf
		Next		
	EndFunction
	Function playerteleport(feld:Byte[,] Var, pos_x:Int Var, pos_y:Int Var, mov_x:Int, mov_y:Int)
		Local movok:Int=0, t:TTeleport
		For t=EachIn list
			If t.src_x=pos_x And t.src_y=pos_y Then
				movok=1
				If feld[t.dst_x,t.dst_y]&$4 Then

					If t.dst_x+mov_x<0 Or t.dst_x+mov_x>=feld.dimensions()[0] Or t.dst_y+mov_y<0 Or ..
											t.dst_y+mov_y>=feld.dimensions()[1] Then movok=0;Exit
					If feld[t.dst_x+mov_x,t.dst_y+mov_y]&$4 Or feld[t.dst_x+mov_x,t.dst_y+mov_y]&$3=0 Then
						feld[t.dst_x,t.dst_y]:&(~$4)
						feld[pos_x,pos_y]:|$4
					EndIf
				EndIf
				If movok Then
					pos_x=t.dst_x
					pos_y=t.dst_y
				EndIf
				Exit
			ElseIf t.dst_x=pos_x And t.dst_y=pos_y Then
				movok=1
				If feld[t.src_x,t.src_y]&$4 Then
					If t.src_x+mov_x<0 Or t.src_x+mov_x>=feld.dimensions()[0] Or t.src_y+mov_y<0 Or ..
											t.src_y+mov_y>=feld.dimensions()[1] Then movok=0;Exit
					If feld[t.src_x+mov_x,t.src_y+mov_y]&$4 Or feld[t.src_x+mov_x,t.src_y+mov_y]&$3=0 Then
						feld[t.src_x,t.src_y]:&(~$4)
						feld[pos_x,pos_y]:|$4
					EndIf
				EndIf
				If movok Then
					pos_x=t.src_x
					pos_y=t.src_y
				EndIf
				Exit

			EndIf
		Next
		If feld[pos_x,pos_y]&$4 And feld[pos_x+mov_x,pos_y+mov_y]&$4=0 And movok Then
			feld[pos_x,pos_y]:&(~$4)
			feld[pos_x+mov_x,pos_y+mov_y]:|$4
		ElseIf Not movok And t Then
			If t.dst_x=pos_x And t.dst_y=pos_y And feld[t.src_x,t.src_y]&$4 Then
				feld[t.src_x,t.src_y]:&(~$4)
				feld[t.dst_x,t.dst_y]:|$4
				pos_x=t.src_x ; pos_y=t.src_y
			ElseIf t.src_x=pos_x And t.src_y=pos_y And feld[t.dst_x,t.dst_y]&$4 Then
				feld[t.dst_x,t.dst_y]:&(~$4)
				feld[t.src_x,t.src_y]:|$4
				pos_x=t.dst_x ; pos_y=t.dst_y
			EndIf
		EndIf
	EndFunction
	Method draw(zentral_x:Int,zentral_y:Int)
		If gfx Then
			SetColor 255,255,255
			DrawImage gfx,zentral_x+src_x*FELD_BREITE,zentral_y+src_y*FELD_BREITE,9
			If dst_x>=0 And dst_y>=0 Then ..
				DrawImage gfx,zentral_x+dst_x*FELD_BREITE,zentral_y+dst_y*FELD_BREITE,9
		Else
			SetColor 255,255,0
			DrawRect zentral_x+src_x*FELD_BREITE+FELD_BREITE/2-3,zentral_y+src_y*FELD_BREITE,6,FELD_BREITE
			If dst_x>=0 And dst_y>=0 Then ..
				DrawRect zentral_x+dst_x*FELD_BREITE,zentral_y+dst_y*FELD_BREITE+FELD_BREITE/2-3,FELD_BREITE,6
		EndIf
	EndMethod
EndType

Const SCORE_PLAETZE:Int=4
Const SCORE_NAMELEN:Int=10
Type TLevelGroup
	Global Current:TLevelGroup
	Global list:TList=New TList
	Global set_x:Int=10, set_y:Int=60
	Field name:String, button:T_MMButton
	Field error:Int
	Field levelname:String[]
	Field scorename:String[], scorev:Int[]
	Field checktime:Int
	Function Create(name:String)
		Local g:TLevelGroup=New TLevelGroup
		g.name=StripExt(name)
		If set_y>=GH-40 Then set_y=60;set_x:+140
		set_y:+24
		g.button=T_MMButton.Create(g.name,set_x,set_y)
		list.addlast g
		g.LoadHighscore
		g.check True
	EndFunction
	Function Get:TLevelGroup(name:String)
		For Local g:TLevelGroup=EachIn list
			If g.name=name Then Return g
		Next
		Return Null
	EndFunction
	Method check(imm:Int=False)
		Local datei:TStream, file:String, nfile:String, ofile:String
		Local dx:Int, dy:Int, pos_x:Int, pos_y:Int
		Local x:Int, y:Int, tmp:Int
		Local size:Int
		Local teleportsystems:Int
		levelname=Null
		
		If imm Or MilliSecs()>checktime Then
			error=0
			file=INITLEV
			#outer_checkloop
			While file
				levelname:+[file]
				size=FileSize(name+LEVDIREXT+"/"+file)
				If FileType(name+LEVDIREXT+"/"+file)<>1 Or size<5 Then error=1;Exit
				datei=ReadFile(name+LEVDIREXT+"/"+file)
				If datei=Null Then error=2;Exit
				tmp=ReadByte(datei)
				If tmp Then nfile=ReadString(datei,tmp) Else nfile=""
				dx=ReadByte(datei)
				dy=ReadByte(datei)
				pos_x=ReadByte(datei)
				pos_y=ReadByte(datei)
				If dx=0 Or dy=0 Then error=6;Exit
				If pos_x>=dx Or pos_y>=dy Then error=3;Exit
				teleportsystems=ReadByte(datei)
				If dx Mod 2 <> 0 Then dx:+1
				If dy Mod 2 <> 0 Then dy:+1
				For y=0 Until dy
					For x=0 Until dx Step 2
						If Eof(datei) Then error=4;Exit outer_checkloop
						ReadByte datei
					Next
				Next
				For teleportsystems=teleportsystems Until 0 Step -1
					If size-datei.pos()<4 Then error=5;Exit outer_checkloop
					ReadInt datei
				Next
				CloseFile datei
				ofile=file
				file=nfile
			Wend
			checktime=MilliSecs()+10000
		EndIf
	EndMethod
	Function Enter(level:String)
		Current=Get(level)
	EndFunction
	Function Leave()
		Current=Null
	EndFunction
	Function drawall()
		For Local g:TLevelGroup=EachIn list
			g.button.draw
		Next
	EndFunction
	Function SaveChanges()
		For Local g:TLevelGroup=EachIn list
			g.SaveHighscore
		Next
	EndFunction
	Method DeleteHighscore()
		If FileType(name+LEVDIREXT+"/"+HIGHSCOREF) Then DeleteFile name+LEVDIREXT+"/"+HIGHSCOREF
		CleanHighscore
	EndMethod
	Method CleanHighscore()
		Local datei:TStream, k:Int
		k=10-STR_STDNAME.length
		datei=WriteFile(name+LEVDIREXT+"/"+HIGHSCOREF)
		For Local i:Int=1 To SCORE_PLAETZE
			WriteString datei,STR_STDNAME
			For Local i:Int=1 To k
				WriteByte datei,32
			Next
			WriteInt datei,$7FFFFFFF
		Next
		CloseFile datei
	EndMethod
	Method LoadHighscore()
		Local datei:TStream
		scorename=Null ; scorev=Null
		If FileType(name+LEVDIREXT+"/"+HIGHSCOREF)<>1 Or ..
				FileSize(name+LEVDIREXT+"/"+HIGHSCOREF)<>SCORE_PLAETZE*(SCORE_NAMELEN+4) Then ..
						CleanHighscore
		datei=ReadFile(name+LEVDIREXT+"/"+HIGHSCOREF)
		For Local i:Int=1 To SCORE_PLAETZE
			scorename:+[ReadString(datei,SCORE_NAMELEN)]
			scorev:+[ReadInt(datei)]
		Next
		CloseFile datei
	EndMethod
	Method SaveHighscore()
		Local datei:TStream, i:Int, k:Int
		datei=WriteFile(name+LEVDIREXT+"/"+HIGHSCOREF)
		For i=0 Until SCORE_PLAETZE
			WriteString datei,scorename[i]
			k=scorename[i].length
			While k<SCORE_NAMELEN ; WriteByte datei,32 ; k:+1 ; Wend
			WriteInt datei,scorev[i]
		Next
		CloseFile datei
	EndMethod
EndType

Type TMenuGUI
	Global mx:Int, my:Int
	Global mxs:Int,mys:Int,mzs:Int
	Global mdleft:Int,mdright:Int
	Global mhleft:Int,mhright:Int
	Global org_x:Int, org_y:Int
	Function update()
		mx=MouseX()
		my=MouseY()
		mxs=MouseXSpeed()
		mys=MouseYSpeed()
		mzs=MouseZSpeed()
		mdleft=MouseDown(MOUSE_LEFT)
		mdright=MouseDown(MOUSE_RIGHT)
		mhleft=MouseHit(MOUSE_LEFT)
		mhright=MouseHit(MOUSE_RIGHT)	
	EndFunction	
	Function neworigin(x:Int, y:Int)
		mx:+org_x-x
		my:+org_y-y
	EndFunction
	Function mousein:Int(x:Int,y:Int,w:Int,h:Int)
		Return mx>x And mx<x+w And my>y And my<y+h
	EndFunction
EndType


Type T_MMButton
	Global asource:T_MMButton, adata:Int
	Global rasterf(b:T_MMButton)
	Field name:String, x:Int, y:Int, w:Int, h:Int
	Field sx:Int, sy:Int
	Field img:TImage, imgblend:Float, clicktime:Int
	Function Create:T_MMButton(name:String,x:Int,y:Int)
		Local b:T_MMButton=New T_MMButton, p:TPixmap
		b.name=name
		If FileType(name+LEVDIREXT+"/"+MENULEVHG) Then b.img=LoadImage(name+LEVDIREXT+"/"+MENULEVHG)
		p=Null
		b.x=x ; b.y=y
		b.w=TextWidth(name)+10
		If b.w<100 Then b.w=100
		b.h=20
		Return b
	EndFunction
	Function drawlevelhg()
		If asource Then
			If asource.img And asource.imgblend>0 Then
				SetColor 255,255,255
				SetAlpha asource.imgblend
				TileImage asource.img
				SetAlpha 1
			EndIf	
		EndIf
	EndFunction
	Method draw()
		Local ret:Int
		If asource=Self Then
			If imgblend<1 Then imgblend:+0.1
			If adata=4 Then
				If TMenuGUI.mdleft Then
					ret=4
					x:+TMenuGUI.mxs;y:+TMenuGUI.mys
				Else
					If rasterf Then rasterf Self
				EndIf
			EndIf
		EndIf
		If ret<>4 And TMenuGUI.mousein(x,y,w+20,h) Then
			ret=1
			If TMenuGUI.mousein(x,y,w,h) And TMenuGUI.mdleft And Not clicktime Then clicktime=MilliSecs()
			If clicktime And TMenuGUI.mdleft=0 Then ret=2;clicktime=0 ..
			ElseIf TMenuGUI.mdright Then ret=3
			If TMenuGUI.mousein(x+w,y,20,h) And TMenuGUI.mdleft Then sx=x; sy=y; ret=4
		ElseIf ret<>4 And imgblend>0 Then
			imgblend:-0.1
			If imgblend<0.1 Then imgblend=0
		ElseIf clicktime And Not TMenuGUI.mdleft Then
			clicktime=0
		EndIf
		If asource And asource<>Self Then SetAlpha 0.3
		SetColor 200,120,0
		DrawRect x+w+2,y+2,16,h-4
				
		
		If ret<>3 Then SetColor 160,160,255 Else SetColor 255,140,130
		DrawRect x,y,w,h
		SetColor 0,0,0
		DrawText name,x+(w-TextWidth(name))/2,y+(h-TextHeight(name))/2
		If asource And asource<>Self Then SetAlpha 1
		
		If asource=Self And ret=0 Then asource=Null
		If ret And (asource=Null Or asource=Self) Then
			SetColor 0,0,0
			DrawRect x+(w-TextWidth(name))/2-1,y+(h+TextHeight(name))/2-2,TextWidth(name)+2,2
			asource=Self
			adata=ret
		EndIf
	EndMethod
EndType

Rem
	Loads servers out of ROOTSERVF (initially server.txt) and saves them as TServer objects.
EndRem
Function loadrootservers()
	Local datei:TStream=ReadFile(ROOTSERVF),y:Int
	Local name:String, server:String, path:String, ip:Int
	If datei=Null Then Return
	While Not Eof(datei)
		name=ReadLine(datei)
		server=name[name.find("|")+1..]
		path=server[server.find("|")+1..].Trim()
		server=server[..server.find("|")].Trim()
		name=name[..name.find("|")].Trim()
		ip=TNetwork.gethostip(server)
		If ip=0 Then ip=TNetwork.intip(server)
		If ip Then TServer.Create name,path,ip
	Wend
	CloseFile datei
EndFunction

Function LEGetNewLevelName:String(level:TLevelGroup)
	Local i:Int
	For i=1 To 10000
		If FileType(level.name+LEVDIREXT+"/"+i+".bin")<>1 Then Return i+".bin"
	Next
	error "Konnte keinen Levelnamen generieren - diese Nachricht sollte nie auftauchen!"
	End
EndFunction

Function LECreateNewLevel:String(level:TLevelGroup)
	Local name:String=LEGetNewLevelName(level)
	Local datei:TStream=WriteFile(level.name+LEVDIREXT+"/"+name)
	WriteByte datei,0
	WriteShort datei,$0A0A
	WriteShort datei,0
	WriteByte datei,0
	For Local i:Int=1 To 100
		WriteByte datei,$22
	Next
	CloseFile datei
	Return name
EndFunction

Function LESaveFile(file:String, feld:Byte[,] Var, nextlevel:String, dx:Int, dy:Int, pos_x:Int, pos_y:Int)
	Local datei:TStream, t:TTeleport
	For t=EachIn TTeleport.list
		If t.dst_x=-1 And t.dst_y=-1 Then TTeleport.list.remove t
	Next
	If nextlevel.length>250 Then nextlevel=nextlevel[..250]
	CopyFile dir+file,dir+file+".bak"
	datei=WriteFile(dir+file)
	WriteByte datei,nextlevel.length
	WriteString datei,nextlevel
	WriteByte datei,dx
	WriteByte datei,dy
	WriteByte datei,pos_x
	WriteByte datei,pos_y
	WriteByte datei,TTeleport.list.count()
	For Local y:Int=0 Until dy
		For Local x:Int=0 Until dx Step 2
			WriteByte datei,(feld[x,y] Shl 4) | feld[x+1,y]
		Next
	Next
	For t=EachIn TTeleport.list
		WriteByte datei,t.src_x
		WriteByte datei,t.src_y
		WriteByte datei,t.dst_x
		WriteByte datei,t.dst_y
	Next
	CloseFile datei
EndFunction

Function LevelEditor(level:TLevelGroup, file:String)
	Local feld:Byte[,], nextlevel:String, pos_x:Int, pos_y:Int
	Local zentral_x:Int, zentral_y:Int, dx:Int, dy:Int, action:Int
	Local view:TImage, cursel:Int=0, tmptele:TTeleport
	Local x:Int, y:Int
	dir=level.name+LEVDIREXT+"/"
	FELD_BREITE=FELD_BREITE_STD
	Load file,nextlevel,pos_x,pos_y,feld
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	If FileType(dir+GFXF) Then
		LoadGFX
		If gfx=Null Then FELD_BREITE=FELD_BREITE_STD
	EndIf
	If FileType(dir+GFXHG) Then hg=LoadImage(dir+GFXHG)
	zentral_x=(GW-dx*FELD_BREITE)/2
	zentral_y=(GH-dy*FELD_BREITE)/2
	view=CreateImage(dx*FELD_BREITE,dy*FELD_BREITE)
	action=1
	Repeat
		Cls
		
		TMenuGUI.update

		If action Then
			SetColor 255,255,255
			drawground zentral_x,zentral_y,feld
			drawother pos_x,pos_y,zentral_x,zentral_y,feld
			SetColor 255,255,255
			GrabImage view,zentral_x,zentral_y
			action=0
		EndIf

		If level.button.img Then
			SetAlpha 0.7
			SetColor 255,255,255
			TileImage level.button.img
		EndIf
		SetColor 0,0,0
		SetAlpha 0.4
		DrawRect 0,0,TextWidth(STR_LEVGRP+": "+level.name)+20,80
		SetAlpha 1
		SetColor 255,150,0
		DrawText STR_LE,10,10
		SetColor 255,255,255
		DrawText STR_LEVGRP+": "+level.name,10,30
		DrawText STR_FILE+": "+file,10,50
		

		SetColor 0,0,0
		DrawRect zentral_x,zentral_y,dx*FELD_BREITE,dy*FELD_BREITE
		SetColor 255,255,255
		DrawImage view,zentral_x,zentral_y
		
		If cursel>0 And TMenuGUI.mzs<0 Then cursel:-1
		If cursel<6 And TMenuGUI.mzs>0 Then cursel:+1
		
		If gfx Then DrawImage gfx,TMenuGUI.mx-FELD_BREITE/2,TMenuGUI.my-FELD_BREITE/2,cursel+3
				
		If TMenuGUI.mousein(zentral_x,zentral_y,dx*FELD_BREITE,dy*FELD_BREITE) Then
			If TMenuGUI.mdleft Then
				x=(TMenuGUI.mx-zentral_x)/FELD_BREITE
				y=(TMenuGUI.my-zentral_y)/FELD_BREITE
				Select cursel
				Case 0
					pos_x=x ; pos_y=y
					action=1
				Case 1,2,3,4
					If feld[x,y] & $3 <> cursel-1 And (cursel<>1 Or (TTeleport.isteleport(x,y)=0 And feld[x,y]&$4=0)) Then
						feld[x,y]=cursel-1
						action=1
					EndIf
				Case 5
					If feld[x,y] & $4=0 Then
						feld[x,y]:|$4
						action=1
					EndIf
				Case 6
					If TTeleport.isteleport(x,y)=0 And feld[x,y] & $3 > 1 Then
						tmptele=TTeleport(TTeleport.list.last())
						If tmptele.dst_x=-1 And tmptele.dst_y=-1 Then
							tmptele.dst_x=x
							tmptele.dst_y=y
						Else
							TTeleport.Create x,y,-1,-1
						EndIf
						action=1
					EndIf
				EndSelect
			ElseIf TMenuGUI.mdright Then
				x=(TMenuGUI.mx-zentral_x)/FELD_BREITE
				y=(TMenuGUI.my-zentral_y)/FELD_BREITE
				If TTeleport.isteleport(x,y) Then
					TTeleport.deleteteleport x,y
					action=1
				ElseIf feld[x,y] & $4 Then
					feld[x,y]:&(~$4)
					action=1
				EndIf
			EndIf
		EndIf
		
		If DrawButton(STR_SAVE,GW-TextWidth(STR_SAVE)-20,GH-40,TextWidth(STR_SAVE)+10,30)=2 Then..
			LESaveFile file, feld, nextlevel, dx, dy, pos_x, pos_y
		
		If AppTerminate() Then End
		
		Flip 0
		WaitTimer timer
	Until KeyHit(KEY_ESCAPE)
	dir=Null
EndFunction

Function LESaveNextfile(level:TLevelGroup,file:String,nextlevel:String)
	Local datei:TStream
	Local seek:Int, size:Int, mem:Byte Ptr, memsize:Int
	file=level.name+LEVDIREXT+"/"+file
	datei=ReadFile(file)
	If datei=Null Then End
	size=FileSize(file)
	seek=ReadByte(datei)
	datei.seek seek+1
	memsize=size-seek-1
	mem=MemAlloc(memsize)
	datei.readbytes mem,memsize
	CloseFile datei
	datei=WriteFile(file)
	WriteByte datei,nextlevel.length
	If nextlevel.length Then WriteString datei,nextlevel
	datei.writebytes mem,memsize
	CloseFile datei
EndFunction

Function SearchNextButton:T_MMButton(buttons:T_MMButton[],y:Int)
	Local imb:T_MMButton,b:T_MMButton
	For b=EachIn buttons
		If b.y>y And (imb=Null Or b.y<imb.y) Then imb=b
	Next
	Return imb
EndFunction

Function LESaveOrder(level:TLevelGroup,buttons:T_MMButton[])
	Local i:Int,y:Int, b:T_MMButton, b2:T_MMButton
	Local dir:String, delfile:String
	dir=level.name+LEVDIREXT+"/"	
	If FileType(INITBAKF)=1 Then DeleteFile INITBAKF
	CopyFile dir+"init.bin",INITBAKF
	Repeat
		b=SearchNextButton(buttons,y)
		If b Then y=b.y+1 Else Exit
		If b2 Then
			If b.name="init.bin" Then b.name=delfile;CopyFile INITBAKF,dir+b.name
			LESaveNextfile level,b2.name,b.name
		ElseIf b.name<>"init.bin" Then
			delfile=b.name
			DeleteFile "init.bin"
			CopyFile dir+b.name,dir+"init.bin"
			b.name="init.bin"
		EndIf
		b2=SearchNextButton(buttons,y)
		If b2 Then 
			If b2.name="init.bin" Then b2.name=delfile;CopyFile INITBAKF,dir+b2.name
			y=b2.y+1 
			LESaveNextfile level,b.name,b2.name 
		Else
			LESaveNextfile level,b.name,Null
		EndIf
	Forever
	DeleteFile INITBAKF
EndFunction

Function LEMenuRasterf(b:T_MMButton)
	b.x=b.sx
	b.y=b.sy
EndFunction
Function LevelEditorMenu(level:TLevelGroup)
	Local buttons:T_MMButton[],b:T_MMButton,sy:Int
	Local listorigin:Float, listorgv:Float
	Local menuy:Int,ret:Int,selbutton:T_MMButton
	Local imb:T_MMButton
	T_MMButton.rasterf=LEMenuRasterf
	T_MMButton.asource=Null
	level.check True
	sy=20
	For Local s:String=EachIn level.levelname
		sy:+24
		b=T_MMButton.Create(s,GW/2,sy)
		b.x=(GW-b.w)/2-20
		buttons:+[b]
	Next
	Repeat
		Cls
	
	
		If level.button.img Then
			SetAlpha 0.7
			SetColor 255,255,255
			TileImage level.button.img
			SetAlpha 1
		EndIf

		SetColor 0,0,0
		SetAlpha 0.4
		DrawRect 0,0,Max(TextWidth(STR_LEVGRP+": "+level.name),TextWidth(STR_LEMENU))+20,60
		SetAlpha 1
		SetColor 255,150,0
		DrawText STR_LEMENU,10,10
		SetColor 255,255,255
		DrawText STR_LEVGRP+": "+level.name,10,30


		TMenuGUI.update

		If Not T_MMButton.asource And TMenuGUI.mdleft And TMenuGUI.mys<>0 Then listorgv=TMenuGUI.mys
		If listorgv Then listorigin:+listorgv;listorgv:*0.92
		If listorigin<-buttons.length*24-44 Then listorigin=-buttons.length*24-44
		If listorigin>GH-buttons.length*24-44 Then listorigin=GH-buttons.length*24-44
		
		If DrawButton(STR_NEW,10,GH-40,40,30)=2 Then
			sy:+24
			b=T_MMButton.Create(LECreateNewLevel(level),GW/2,sy)
			b.x=(GW-b.w)/2-20
			buttons:+[b]
		EndIf
		If DrawButton(STR_SAVE,GW-TextWidth(STR_SAVE)-20,GH-40,TextWidth(STR_SAVE)+10,30)=2 Then
			LESaveOrder level,buttons
		EndIf

		SetOrigin 0,listorigin
		TMenuGUI.neworigin 0,listorigin
		If selbutton Then
			SetAlpha 0.5
			SetColor 255,255,0
			DrawRect 0,selbutton.y-2,GW,24
			SetAlpha 1
			If DrawButton("Up",10,selbutton.y,40,20)=2 Then
				imb=Null
				For b=EachIn buttons
					If b<>selbutton And b.y<selbutton.y And (imb=Null Or imb.y<b.y) Then imb=b
				Next
				If imb Then
					imb.y:+24; imb.sy=imb.y
					selbutton.y:-24; selbutton.sy=selbutton.y
					MoveMouse TMenuGUI.mx,selbutton.y+5+listorigin
					FlushMouse
				EndIf
			EndIf
			If DrawButton("Down",60,selbutton.y,40,20)=2 Then
				imb=Null
				For b=EachIn buttons
					If b<>selbutton And b.y>selbutton.y And (imb=Null Or imb.y>b.y) Then imb=b
				Next
				If imb Then
					imb.y:-24; imb.sy=imb.y
					selbutton.y:+24; selbutton.sy=selbutton.y
					MoveMouse TMenuGUI.mx,selbutton.y+5+listorigin
					FlushMouse
				EndIf
			EndIf
		EndIf
		For Local b:T_MMButton=EachIn buttons
			b.draw
		Next
		SetOrigin 0,0
		TMenuGUI.neworigin 0,0
		If T_MMButton.asource Then
			If T_MMButton.adata=4 Then
				selbutton=T_MMButton.asource
			EndIf
			If T_MMButton.adata=2 Then 
				LevelEditor level,T_MMButton.asource.name
				hg=Null
				gfx=Null
				TTeleport.list.clear
			EndIf
		EndIf
		
		
		If AppTerminate() Then End
		
		Flip 0
		WaitTimer timer
	Until KeyHit(KEY_ESCAPE)
	T_MMButton.asource=Null
EndFunction

Function MMenuRasterf(b:T_MMButton)
	b.x=Int((b.x+60)/140.0)*140 + 10
	b.y=Int((b.y-68)/24.0)*24   + 84	
EndFunction

Function MenuLoadLevels()
	Local this:String[]=LoadDir("."), s:String
	TLevelGroup.list.clear
	TLevelGroup.set_x=10
	TLevelGroup.set_y=60
	For s=EachIn this
		If s.endswith(LEVDIREXT) And FileType(s)=2 Then TLevelGroup.Create s
	Next
EndFunction

Function Menu()
	Local scorelevel:String
	Local group:String[], s:String, w:Int, sx:Int, sy:Int
	Local newload:Float, delsince:Int, alevel:TLevelGroup
	Local checkserver:Int
	MenuLoadLevels
	TServer.updateall
	TServer.CheckFunctionsAll
	checkserver=MilliSecs()+5000
	T_MMButton.rasterf=MMenuRasterf
	Repeat
		Cls
		
		TMenuGUI.update
		T_MMButton.drawlevelhg
		SetColor 0,120,200
		DrawRect 20,GH-20,GW/2-40,20
		w=TextWidth(STR_LEVEDIT)
		SetColor 255,255,255
		DrawText STR_LEVEDIT,GW/4-w/2,GH-18
		
		
		If TServer.onlineservers=0 Then SetColor 120,120,120 Else SetColor 200,120,0
		DrawRect GW/2+20,GH-20,GW/2-40,20
		w=TextWidth(STR_SERVER)
		SetColor 255,255,255
		DrawText STR_SERVER,3*GW/4-w/2,GH-18
		
		
		
		sx=10
		sy=60
		
		TLevelGroup.drawall
		SetColor 0,0,0
		SetAlpha 0.4
		DrawRect 5,5,TextWidth(AppTitle)+10,26
		SetColor 200,120,0
		SetAlpha 1
		DrawText AppTitle,10,10

		If TMenuGUI.mousein(GW/2+20,GH-20,GW/2-40,20) And MilliSecs()>checkserver Then
			TServer.updateall
			checkserver=MilliSecs()+20000
		EndIf
		
		If TMenuGUI.mdleft And TMenuGUI.mys<-80 Then MenuLoadLevels
		
		If T_MMButton.asource Then
			alevel=TLevelGroup.Get(T_MMButton.asource.name)
			If Not alevel Then error "No level with name '"+T_MMButton.asource.name+"'";Continue
			If alevel.error Then
				SetColor 0,0,0
				DrawRect alevel.button.x+alevel.button.w+20,alevel.button.y,TextWidth(STR_LEVERR)+20,20
				SetColor 255,0,0
				DrawText STR_LEVERR,alevel.button.x+alevel.button.w+30,alevel.button.y+2
			EndIf
			If T_MMButton.adata<>3 Then delsince=0
			Select T_MMButton.adata
			Case 4
				If TMenuGUI.mousein(GW/2+20,GH-20,GW/2-40,20) And TServer.onlineservers Then
					'servermenu T_MMButton.asource
				ElseIf TMenuGUI.mousein(20,GH-20,GW/2-40,20) Then
					LevelEditorMenu alevel
					T_MMButton.rasterf=MMenuRasterf
					alevel.button.x=alevel.button.sx
					alevel.button.y=alevel.button.sy
				ElseIf TMenuGUI.mxs>100 Or TMenuGUI.mx>=GW-1 Then
					TLevelGroup.list.remove alevel
					T_MMButton.asource=Null
					alevel=Null
				EndIf
			Case 3
				If delsince=0 Then delsince=MilliSecs()
				If delsince And MilliSecs()-delsince>2000 And alevel Then
					alevel.DeleteHighscore
					alevel.LoadHighscore
					delsince=MilliSecs()
				EndIf
			Case 2
				alevel.check True
				If Not alevel.error Then
					dir=T_MMButton.asource.name+LEVDIREXT+"/"
					currentlevel=INITLEV
					HideMouse
					TLevelGroup.Enter T_MMButton.asource.name
					Main
					TLevelGroup.Leave
					ShowMouse
					FlushMouse
					FlushKeys
					dir=""
					Cls
					checkserver=MilliSecs()+200
					Continue
				EndIf
			Case 1
				alevel.check
				If scorelevel<>T_MMButton.asource.name Then
					scorelevel=T_MMButton.asource.name
					'DebugLog GetUIN(scorelevel)
				EndIf
			EndSelect
		EndIf
		sx=320
		sy=10
		If newload<1 Then newload:+0.1
		If T_MMButton.asource And alevel And alevel.scorename Then
			SetColor 0,0,0
			SetAlpha 0.4
			DrawRect sx-5,sy-5,310,16*alevel.scorename.length+10
			DrawRect 5,35,TextWidth(alevel.name)+10,26
			SetAlpha newload
			SetColor 255,255,255
			DrawText alevel.name,10,40
			For Local i:Int=0 Until Min(alevel.scorename.length,alevel.scorev.length)
				s=String(i+1)+". "+alevel.scorename[i]
				s:+" ... "+alevel.scorev[i]+" "+STR_STEPS
				DrawText s,sx,sy
				sy:+16
			Next
			SetAlpha 1
		EndIf
		
		
		Flip 0
		WaitTimer timer
	Until KeyHit(KEY_ESCAPE) Or AppTerminate()
EndFunction

Function DrawButton:Int(s:String,x:Int,y:Int,w:Int,h:Int,rightpart:Int=False)
	Local ret:Int
	If TMenuGUI.mousein(x,y,w,h) Then
		ret=1
		If TMenuGUI.mhleft Then ret=2 ..
		ElseIf TMenuGUI.mdright Then ret=3
	EndIf
	If rightpart Then
		SetColor 255,150,0
		DrawRect x+w,y,20,h
		SetColor 255,100,0
		DrawRect x+w,y+h/2,20,h/2
		If TMenuGUI.mousein(x+w,y,20,h) And TMenuGUI.mdleft Then ret=4
	EndIf
	If ret<>3 Then SetColor 160,160,255 Else SetColor 255,140,130
	DrawRect x,y,w,h
	SetColor 0,0,0
	DrawText s,x+(w-TextWidth(s))/2,y+(h-TextHeight(s))/2
	
	If ret Then
		SetColor 0,0,0
		DrawRect x+(w-TextWidth(s))/2-1,y+(h+TextHeight(s))/2-2,TextWidth(s)+2,2
	EndIf
	Return ret
EndFunction

Function GetUIN:String(group:String)
	Local datei:TStream
	Local pos_x:Int, pos_y:Int
	Local x:Int, y:Int
	Local dx:Int, dy:Int
	Local teleportsystems:Int
	Local tmp:Int,tmp2:Int
	Local uintmp:String
	Local currentfile:String=INITLEV
	dir=group+"/"
	
	While currentfile
		If FileType(dir+currentfile)<>1 Or FileSize(dir+currentfile)<5 Then error STR_ERR2;Return Null
		datei=ReadFile(dir+currentfile)
		If datei=Null Then error STR_ERR2;Return Null
		tmp=ReadByte(datei)
		If tmp Then currentfile=ReadString(datei,tmp) Else currentfile=Null
		dx=ReadByte(datei)
		dy=ReadByte(datei)
		pos_x=ReadByte(datei)
		pos_y=ReadByte(datei)
		teleportsystems=ReadByte(datei)
		uintmp:+Chr((pos_x*pos_y+teleportsystems) Mod 64 + 33)
		For y=0 Until dy
			For x=0 Until dx Step 2
				If Eof(datei) Then error STR_ERR1;Return Null
				tmp=ReadByte(datei)
				uintmp:+Chr((x*(tmp Shl 4 + tmp)+y) Mod 64 + 33)
			Next
		Next
		uintmp="A"+uintmp
		CloseFile datei
	Wend
	dir=Null
	Return Hash(uintmp)
EndFunction


Function Load(file:String, nextlevel:String Var, pos_x:Int Var, pos_y:Int Var, array:Byte[,] Var)
	Local datei:TStream
	Local dx:Int, dy:Int
	Local x:Int, y:Int
	Local teleportsystems:Int
	Local tmp:Int,tmp2:Int
	Local uintmp:String
	TTeleport.list.clear
	If FileType(dir+file)<>1 Or FileSize(dir+file)<5 Then Notify "1";array=Null;Return
	datei=ReadFile(dir+file)
	If datei=Null Then array=Null;Return
	tmp=ReadByte(datei)
	If tmp Then nextlevel=ReadString(datei,tmp)
	dx=ReadByte(datei)
	dy=ReadByte(datei)
	pos_x=ReadByte(datei)
	pos_y=ReadByte(datei)
	teleportsystems=ReadByte(datei)
	uintmp:+Chr(pos_x*pos_y+teleportsystems)
	If dx Mod 2 <> 0 Then dx:+1
	If dy Mod 2 <> 0 Then dy:+1
	array=New Byte[dx,dy]
	#outer_loadloop
	For y=0 Until dy
		For x=0 Until dx Step 2
			If Eof(datei) Then array=Null; Exit outer_loadloop
			tmp=ReadByte(datei)
			array[x,y]=(tmp Shr 4) & $F
			array[x+1,y]=tmp & $F
			uintmp:+Chr(array[x,y] Shl 4 + array[x,y])
		Next
	Next
	If array Then
		For teleportsystems=teleportsystems Until 0 Step -1
			x=ReadByte(datei)
			y=ReadByte(datei)
			tmp=ReadByte(datei)
			tmp2=ReadByte(datei)
			TTeleport.Create x,y,tmp,tmp2
		Next
	EndIf
	CloseFile datei
EndFunction

Function error(s:String)
	SetClsColor 0,0,255
	Cls
	SetColor 160,160,160
	DrawText s,81,11
	SetColor 255,255,255
	DrawText s,80,10
	DrawText STR_ERROR+":",10,10
	DrawText STR_ANYKEY,10,30
	Flip
	Delay 150
	FlushKeys
	WaitKey
	SetClsColor 0,0,0
EndFunction

Function LoadGFX()
	Local p:TPixmap=LoadPixmap(dir+GFXF)
	FELD_BREITE=PixmapHeight(p)
	If PixmapWidth(p)<>FELD_BREITE*10 Then Return
	p=Null
	gfx=LoadAnimImage(dir+GFXF,FELD_BREITE,FELD_BREITE,0,10)
EndFunction

Function Main()
	gfx=Null ; hg=Null
	FELD_BREITE=FELD_BREITE_STD
	If FileType(dir+GFXF) Then
		LoadGFX
		If gfx=Null Then FELD_BREITE=FELD_BREITE_STD
	EndIf
	If FileType(dir+GFXHG) Then hg=LoadImage(dir+GFXHG)
	Game
	TTeleport.list.clear
	FlushMouse	
EndFunction

Function DrawBoxes(zentral_x:Int, zentral_y:Int, feld:Byte[,])
	Local x:Int, y:Int
	Local dx:Int, dy:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	If gfx Then SetColor 255,255,255 Else SetColor 160,80,0
	For y=0 Until dy
		For x=0 Until dx
			If feld[x,y] & $4 Then
				If gfx Then ..
					DrawImage gfx,zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,8 ..
				Else ..
					DrawRect zentral_x+x*FELD_BREITE+2,zentral_y+y*FELD_BREITE+2,FELD_BREITE-4, ..
																FELD_BREITE-4
			EndIf
		Next
	Next
EndFunction

Function Draw(zentral_x:Int, zentral_y:Int, feld:Byte[,])
	Local x:Int, y:Int
	Local dx:Int, dy:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	For y=0 Until dy
		For x=0 Until dx
			If gfx Then
				SetColor 255,255,255
				DrawImage gfx,zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,(feld[x,y]&$3)+4
			Else
				Select feld[x,y] & $3
				Case 0
					SetColor 60,60,60
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
				Case 2
					SetColor 0,180,0
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
				Case 3
					SetColor 0,0,0
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
					SetColor 255,255,255
					DrawRect zentral_x+x*FELD_BREITE+1,zentral_y+y*FELD_BREITE+1,FELD_BREITE-2, ..
																	FELD_BREITE-2
					SetColor 0,0,0
					DrawRect zentral_x+x*FELD_BREITE+2,zentral_y+y*FELD_BREITE+2,FELD_BREITE-4, ..
																	FELD_BREITE-4
				EndSelect
			EndIf
		Next
	Next
EndFunction

Rem
	Checks if Level is completed.
	Each box has to be in a hole (no matter if there are more holes than boxes).
EndRem
Function checkcompleted:Int(feld:Byte[,])
	Local dx:Int,dy:Int
	Local x:Int, y:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	For y=0 Until dy
		For x=0 Until dx
			If feld[x,y]&$4 And feld[x,y]&$3<>3 Then Return False
		Next
	Next
	Return True
EndFunction

Function animation_boxes(pos_x:Int, pos_y:Int, zentral_x:Int, zentral_y:Int, ground:TImage, feld:Byte[,])
	MidHandleImage gfx
	SetColor 255,255,255
	For Local x:Float=0 To 359 Step 15
		If hg Then TileImage hg Else Cls
		DrawImage ground,zentral_x,zentral_y
		SetAlpha x/359.0
		SetRotation x
		drawother pos_x,pos_y,zentral_x+FELD_BREITE/2,zentral_y+FELD_BREITE/2,feld
		SetRotation 0
		SetAlpha 1
		Flip 0
		WaitTimer timer
	Next
	SetImageHandle gfx,0,0
EndFunction

Function Game()
	Local pos_x:Int, pos_y:Int, feld:Byte[,]
	Local start_x:Int, start_y:Int
	Local zentral_x:Int, zentral_y:Int
	Local dx:Int, dy:Int
	Local fehlerzeit:Int
	Local start:Int[,]
	Local ground:TImage
	
	Local totalsteps:Int, steps:Int
	
	
	Repeat
		feld=Null
		Load currentlevel, nextlevel, start_x, start_y, feld
		If feld=Null Then error STR_ERR1;Return
		pos_x=start_x
		pos_y=start_y
		dx=feld.dimensions()[0]
		dy=feld.dimensions()[1]
		zentral_x=(GW-feld.dimensions()[0]*FELD_BREITE)/2
		zentral_y=(GH-feld.dimensions()[1]*FELD_BREITE)/2
		start=New Int[dx,dy]
		For Local y:Int=0 Until dy
			For Local x:Int=0 Until dx
				start[x,y]=feld[x,y]
			Next
		Next
		
		ground=CreateImage(FELD_BREITE*dx,FELD_BREITE*dy,1,DYNAMICIMAGE)
		
		Cls
		drawground zentral_x,zentral_y, feld
		'drawother pos_x, pos_y, zentral_x, zentral_y, feld
		SetColor 255,255,255

		GrabImage ground,zentral_x,zentral_y
				
		For Local x:Int=GW To zentral_x Step -25
			If hg Then SetAlpha 1;TileImage hg Else Cls
			SetAlpha 1.0-Double(x-zentral_x)/(GW-zentral_x)
			DrawImage ground,x,zentral_y
			Flip 0
			WaitTimer timer
		Next
		SetAlpha 1
		Cls
		drawground zentral_x, zentral_y, feld
		SetColor 255,255,255
		GrabImage ground,zentral_x,zentral_y
		
		If gfx Then animation_boxes pos_x, pos_y, zentral_x, zentral_y, ground, feld
		
		FlushKeys
		
		steps=0
		Repeat
			Cls
			If hg Then TileImage hg
				
			If fehlerzeit Then
				SetColor 255,0,0
				If fehlerzeit-MilliSecs()<400 Then ..
					SetAlpha (fehlerzeit-MilliSecs())/400.0
				DrawRect zentral_x-5,zentral_y-5,FELD_BREITE*dx+10,FELD_BREITE*dy+10
				SetAlpha 1
			EndIf
			If KeyHit(KEY_BACKSPACE) Then
				For Local y:Int=0 Until dy
					For Local x:Int=0 Until dx
						feld[x,y]=start[x,y]
					Next
				Next
				fehlerzeit=0
				pos_x=start_x
				pos_y=start_y
				If gfx Then animation_boxes pos_x, pos_y, zentral_x, zentral_y, ground, feld
			EndIf
			SetColor 255,255,255
			DrawImage ground,zentral_x,zentral_y
			drawother pos_x, pos_y, zentral_x, zentral_y, feld

			'drawall pos_x, pos_y, zentral_x, zentral_y, feld
			Select True
			Case KeyHit(KEY_LEFT) Or KeyHit(KEY_A)
				If pos_x>0 And feld[pos_x-1,pos_y]&$3<>0 Then
					If feld[pos_x-1,pos_y] & $4 Then
						If pos_x>1 And feld[pos_x-2,pos_y]&$2 And feld[pos_x-2,pos_y]&$4=0 Then
							pos_x:-1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x-1,pos_y]:|$4
							TTeleport.boxteleport feld,pos_x-1,pos_y
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_x:-1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=3
				TTeleport.playerteleport feld, pos_x, pos_y, -1, 0
			Case KeyHit(KEY_RIGHT) Or KeyHit(KEY_D)
				If pos_x<dx-1 And feld[pos_x+1,pos_y]&$3<>0 Then
					If feld[pos_x+1,pos_y] & $4 Then
						If pos_x+2<dx And feld[pos_x+2,pos_y]&$2 And feld[pos_x+2,pos_y]&$4=0 Then
							pos_x:+1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x+1,pos_y]:|$4
							TTeleport.boxteleport feld,pos_x+1,pos_y
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_x:+1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=2
				TTeleport.playerteleport feld, pos_x, pos_y, 1, 0
			Case KeyHit(KEY_UP) Or KeyHit(KEY_W)
				If pos_y>0 And feld[pos_x,pos_y-1]&$3<>0 Then
					If feld[pos_x,pos_y-1] & $4 Then
						If pos_y>1 And feld[pos_x,pos_y-2]&$2 And feld[pos_x,pos_y-2]&$4=0 Then
							pos_y:-1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x,pos_y-1]:|$4
							TTeleport.boxteleport feld,pos_x,pos_y-1
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_y:-1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=0
				TTeleport.playerteleport feld, pos_x, pos_y, 0, -1
			Case KeyHit(KEY_DOWN) Or KeyHit(KEY_S)
				If pos_y<dy-1 And feld[pos_x,pos_y+1]&$3<>0 Then
					If feld[pos_x,pos_y+1] & $4 Then
						If pos_y+2<dy And feld[pos_x,pos_y+2]&$2 And feld[pos_x,pos_y+2]&$4=0 Then
							pos_y:+1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x,pos_y+1]:|$4
							TTeleport.boxteleport feld,pos_x,pos_y+1
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_y:+1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=1
				TTeleport.playerteleport feld, pos_x, pos_y, 0, 1
			EndSelect
			
			SetAlpha 0.5
			SetColor 0,0,0
			DrawRect 0,0,200,50
			SetAlpha 1
			SetColor 255,255,255
			DrawText STR_TSTEPS+": "+(steps+totalsteps),5,5
			DrawText STR_STEPS+": "+steps,5,25
			
			Flip 0
			WaitTimer timer
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then Return
		Until checkcompleted(feld)
		totalsteps:+steps
		Cls
		If hg Then TileImage hg
		drawground zentral_x, zentral_y, feld
		drawother pos_x, pos_y, zentral_x, zentral_y, feld
		SetColor 255,255,255
		GrabImage ground,zentral_x,zentral_y
		Flip 0
		Delay 250
		For Local x:Int=GW To zentral_x Step -25
			If hg Then SetAlpha 1;TileImage hg Else Cls
			SetAlpha Double(x-zentral_x)/(GW-zentral_x)
			DrawImage ground,x-(GW-zentral_x),zentral_y
			Flip 0
			WaitTimer timer
		Next
		SetAlpha 1
		ground=Null
		currentlevel=nextlevel
		nextlevel=""
	Until Not currentlevel
	Delay 150
	FlushKeys
	SaveScore totalsteps
EndFunction


Function SaveScore(steps:Int)
	Local newname:String, get:Byte, level:TLevelGroup
	level=TLevelGroup.Current
	For Local i:Int=0 Until level.scorev.length
		If steps<level.scorev[i] Then
			SetColor 255,255,255
			Repeat
				Cls
				
				DrawText STR_SCORE+": "+steps,GW/2-105,GH/2-30
				DrawText STR_NAME+":",GW/2-105,GH/2-7
				DrawText newname,GW/2-60,GH/2-7
				
				get=GetChar()
				If get=8 Then newname=newname[..newname.length-1]
				If newname.length<SCORE_NAMELEN Then
					If MilliSecs() Mod 700 < 350 Then DrawRect GW/2-55+TextWidth(newname),GH/2+3,8,5
					If (get>=65 And get<=90) Or (get>=48 And get<=57) Then
						newname:+Chr(get)
					ElseIf get>=97 And get<=122 Then
						newname:+Chr(get-32)
					EndIf
				EndIf
				
				Flip 0
				Delay 20
			Until KeyHit(KEY_RETURN)
			If newname Then
				level.scorename=level.scorename[..i]+[newname]+level.scorename[i..]
				level.scorename=level.scorename[..SCORE_PLAETZE]
				level.scorev=level.scorev[..i]+[steps]+level.scorev[i..]
				level.scorev=level.scorev[..SCORE_PLAETZE]
			EndIf
			Exit
		EndIf
	Next
EndFunction

Function drawground(zentral_x:Int,zentral_y:Int,feld:Byte[,])
	Draw zentral_x, zentral_y, feld
	TTeleport.drawall zentral_x, zentral_y
EndFunction

Function drawother(pos_x:Int,pos_y:Int,zentral_x:Int,zentral_y:Int,feld:Byte[,])
	DrawBoxes zentral_x, zentral_y, feld
	If gfx Then
		SetColor 255,255,255
		DrawImage gfx,zentral_x+pos_x*FELD_BREITE,zentral_y+pos_y*FELD_BREITE,player_dir
	Else
		SetColor 0,0,255
		DrawOval zentral_x+pos_x*FELD_BREITE,zentral_y+pos_y*FELD_BREITE,FELD_BREITE,FELD_BREITE
	EndIf
EndFunction

